import request from '~/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsOrder, CmsOrderParam } from './model';


/**
 * 分页查询订单
 */
export async function pageCmsOrder(params: CmsOrderParam) {
  const res = await request.get<ApiResult<PageResult<CmsOrder>>>(
    '/cms/cms-order/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询订单列表
 */
export async function listCmsOrder(params?: CmsOrderParam) {
  const res = await request.get<ApiResult<CmsOrder[]>>(
    '/cms/cms-order',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加订单
 */
export async function addCmsOrder(data: CmsOrder) {
  const res = await request.post<ApiResult<unknown>>(
      '/cms/cms-order',
      data
  );
  if (res.code === 0) {
    return res;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改订单
 */
export async function updateCmsOrder(data: CmsOrder) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-order',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除订单
 */
export async function removeCmsOrder(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-order/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除订单
 */
export async function removeBatchCmsOrder(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-order/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询订单
 */
export async function getCmsOrder(id: number) {
  const res = await request.get<ApiResult<CmsOrder>>(
    '/cms/cms-order/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
